﻿using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Controls.Primitives;
using System.Windows.Media;
using ExtendedGrid.Classes;
using ExtendedGrid.ExtendedGridControl;
using ExtendedGrid.Interface;
using Microsoft.Windows.Controls;
using Microsoft.Windows.Controls.Primitives;

namespace ExtendedGrid.ExtendedColumn
{
    public class ExtendedDataGridTextColumn : DataGridTextColumn, IExtendedColumn
    {

        #region Members

       

        #endregion

        #region "Attached Properties"

        public Boolean AllowAutoFilter
        {
            get { return (Boolean)GetValue(AllowAutoFilterProperty); }
            set
            {
                SetValue(AllowAutoFilterProperty, value);

            }
        }
        public static readonly DependencyProperty AllowAutoFilterProperty = DependencyProperty.Register(
          "AllowAutoFilter", typeof(Boolean), typeof(ExtendedDataGrid), new PropertyMetadata(true));

        #endregion

        #region Properties

        public bool HasAutoFilter
        {
            get
            {
                var header = FindControls.GetColumnHeaderFromColumn(this);
                if (header != null)
                {
                    var popUp = FindControls.FindChild<Popup>(header, "popupDrag");
                    if (popUp != null)
                    {
                        return Convert.ToString(popUp.Tag) == "True";
                    }
                }


                return false;
            }
        }

        #endregion

       
    }
}
